<?php

namespace Controller;

use Service\Manager\Mongo\Manager;
use Zeedhi\Framework\DTO\Request\Filter;
use Zeedhi\Framework\DTO\Response;

class DynamicAggregate {

    /** @var Manager */
    protected $mongoManager;

    protected $dynamicAggService;

    public function __construct(Manager $mongoManager, \Service\DynamicAggregate $dynamicAggService) {
        $this->mongoManager = $mongoManager;
        $this->dynamicAggService = $dynamicAggService;
    }

    public function aggregate(Filter $filter, Response $response) {
        $filterCriteria = $filter->getFilterCriteria();
        $zmartFilterCriteria = $this->dynamicAggService->convertFilterCriteriaToZmartFilterCriteria($filterCriteria);
        $dataSet = $this->mongoManager->aggregate($zmartFilterCriteria);
        $response->addDataSet($dataSet);
    }


}