<?php
namespace Service\Log;

use Util\Environment;
use Zeedhi\Framework\HTTP\Request;

class LoggerInfoProvider implements \Zeedhi\Framework\HTTP\Logger\LoggerInfoProvider {

    protected $environment;

    public function __construct(Environment $environment) {
        $this->environment = $environment;
    }

    public function getUserData(Request $request) {
        return json_encode(array(
            'userId'           => $this->environment->getUserId(),
            'userName'         => $this->environment->getUserName(),
            'organizationId'   => $this->environment->getOrganizationId(),
            'organizationName' => $this->environment->getOrganizationName()
        ));
    }

    public function getContextData(Request $request) {
        $origin = $request->get('origin', array('containerName' => null, 'widgetName' => null));
        return json_encode($origin);
    }
}