import {ChartViewInterface} from "@/Services/ChartView/ChartViewInterface";
import {ChartViewAbstract} from "@/Services/ChartView/ChartViewAbstract";
import {ZmartChartsApex} from "@/Services/Chats/ZmartChartsApex";

export class Donut extends ChartViewAbstract implements ChartViewInterface {
    public hasMultipleFacts: Boolean = false;

    public getWidget(dashboard: any, widget: any) {
        const height = widget[0].style;
        if (dashboard.label !== '' || dashboard.label !== null) {
            widget[0].options.title.text = dashboard.label;
        }
        widget[0].style = "background: " + dashboard.color + "; " + height;
        return widget;
    }
    public getCharts(charts: any) {
        return charts;
    }

    public setDrill(charts: any, zmartCharts: ZmartChartsApex) {
        this.zmartCharts = zmartCharts;
        this.getZmartCharts().setFormatterFunctions(charts);

        charts[0].options.chart.events = {
            // "click": this.drillApexChart.bind(this),
            "mounted": this.getZmartCharts().mounted.bind(this.getZmartCharts())
        };
        charts[0].options.chart.events.chartClick = this.getZmartCharts().drillApexChart.bind(this.getZmartCharts(), charts[0].widget);

        return charts;
    }
    public getSaveViewParams(formExtra: any, values: any, cleanValues: any) {
        console.log(formExtra, values, cleanValues);
        const chartSeries = [
            {
                serieColor: [null],
                serieColors: values.serieColors || null,
                serieFields: values.serieFields || null,
                serieLabels: values.serieLabels || null,
                serieLineWidth: values.serieLineWidth || null,
                serieStacked: values.serieStacked || null,
                serieLineType: values.serieLineType || null,
                serieYAxisFormat: values.serieYAxisFormat || null,
                serieType: values.serieType || null
            }

        ];
        cleanValues.chartSeries = chartSeries;
        return cleanValues;
    }
}
