import {ChartViewInterface} from "@/Services/ChartView/ChartViewInterface";
import {ChartViewAbstract} from "@/Services/ChartView/ChartViewAbstract";
import {ZmartChartsApex} from "@/Services/Chats/ZmartChartsApex";

export class ListCard extends ChartViewAbstract implements ChartViewInterface {
    public getWidget(dashboard: any, widget: any) {
        const height = widget[0].style;
        if (dashboard.label !== '' || dashboard.label !== null) {
            widget[0].children[0].text = dashboard.label;
        }
        widget[0].style = "background: " + dashboard.color + "; " + height;
        return widget;
    }

    public setDrill(charts: any, zmartCharts: ZmartChartsApex) {
        this.zmartCharts = zmartCharts;
        const cardRows = charts[0].children.filter((row: any) => row.isCardsRow);
            cardRows.forEach((row: any) => {
                row.children.forEach((cardComponent: any) => {
                    cardComponent.events = {
                        "click": this.getZmartCharts().drillCardList.bind(this.getZmartCharts(), cardComponent.widget)
                    };
                });
            });
        return charts;
    }

    public getCharts(charts: any) {
        if (this.getZmartCharts()) {
            this.getZmartCharts().setListCardFormatterFunctions(charts);
        }
        return charts;
    }
}
